;copywrite 2000 Samuel Stearley


ti89

 ifnd ti89
ti92plus
 endc


	include	"os.h"

 ifd ti89
	xdef		_ti89
 endc

 ifd ti92plus
	xdef		_ti92plus
 endc


	xdef		_nostub




;---INSTALL MY EVENT HOOK----

	movem.l	d3-d7/a2-a6,-(a7)
	move.l	a7,d7				;save stack pointer
	move.l	200,a6			;pointer to the jump table
	move.l	2700(a6),a5			;got pointer to old evhook
	lea		old_event(pc),a1		;get pointer to the save space
	move.l	(a5),(a1)			;save it
	move.l	#END_OF_HOOK-BEGINNING_OF_HOOK,d3	;amount of ram needed
	move.l	d3,-(a7)			;ram needed to copy code too
	move.l	584(a6),a0			;get heap allocate high call
	jsr		(a0)				;allocate it -d0 has the handle
	pea		error_message(pc)
	tst.w		d0				;check for success
	beq		memory_error
	move.w	d0,-(a7)			;push for dereferencing
	move.l	600(a6),a0			;get dereference call -ao points to allocated memory
	jsr		(a0)
	move.l	a0,a1
	add.l		#$40010,a0			;increase the first to bypass hw2 protection
	move.l	a0,(a5)			;overwrite old event handler
	subq.l	#1,d3				;for dbra
	lea		BEGINNING_OF_HOOK(pc),a0
copy_loop:
	move.b	(a0)+,(a1)+
	dbra		d3,copy_loop		;copy over the handler
	pea		message(pc)
memory_error:
	move.l	920(a6),a0			;help displag call
	jsr		(a0)

;---Restore Registers and exit the installation-----

final:
	move.l	d7,a7				;reset the stack
	movem.l	(a7)+,d3-d7/a2-a6		;get registers back
	rts

;-----STRINGS-------

error_message:	dc.b	"Not enough memory",0
message		dc.b	"Faster by Samuel Stearley (c) 2001",0



;---------------------------------
;NOW THE CODE OF THE HOOK
;---------------------------------


	EVEN	


BEGINNING_OF_HOOK:

			dc.b		"evHk-FASTER-"
old_event:		dc.l		0		



;----Check for the right circumstances----



	movem.l	d3/a2,-(a7)		;save it
	cmp.w		#$710,(a2)		;is it a key press
	bne		call_next_hook
	move.w	10(a2),d0		;get the key


 ifd ti89

	moveq		#8,d3		;to have it move 10 places
	cmp.w		#16728,d0	;diamond right
	beq		handle_it
	cmp.w		#16722,d0	;diamond left
	beq		handle_it
	moveq		#3,d3		;to have it move 5 places
	cmp.w		#33112,d0
	beq		handle_it
	cmp.w		#33106,d0
	bne		call_next_hook

 endc

 ifd ti92plus

	moveq		#8,d3
	cmp.w		#8532,d0	;diamond right
	beq		handle_it
	cmp.w		#8529,d0	;diamond left
	bne		call_next_hook

 endc


;----Code to send the keypress event repeatedly----

handle_it:
	move.w	8(a2),d1		;get key modifier flags
	eor.w		d1,d0			;remove modifiers
	move.w	d0,10(a2)		;make it a regular arrow
	move.l	a2,-(a7)		;the event
	move.w	#-2,-(a7)		;send it to the current apllication
	move.l	200,a0
	move.l	824(a0),a2		;get send event call
send_loop:
	jsr		(a2)
	dbra		d3,send_loop
	addq.l	#6,a7

;----Code to call the next hook

call_next_hook:
	movem.l	(a7)+,d3/a2			;restore the registers
	move.l	old_event(pc),a0		;get the old event handler
	move.l	a0,d0				;test it
	beq		no_old_hook
	move.l	a2,-(a7)			;input for the event handler
	jsr		(a0)				;call the next event handler
	addq.l	#4,a7				;pop it off
no_old_hook:
	rts



END_OF_HOOK:


	END	